"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var component_generators_1 = require("./component-generators");
var project_utils_1 = require("@teleporthq/teleport-shared/lib/utils/project-utils");
var constants_1 = require("./constants");
var uidl_utils_1 = require("@teleporthq/teleport-shared/lib/utils/uidl-utils");
var teleport_uidl_validator_1 = require("@teleporthq/teleport-uidl-validator");
exports.createVueBasicGenerator = function (generatorOptions) {
    if (generatorOptions === void 0) { generatorOptions = {}; }
    var validator = new teleport_uidl_validator_1.Validator();
    var vueGenerator = component_generators_1.createVueGenerator(generatorOptions);
    var addCustomMapping = function (mapping) {
        vueGenerator.addMapping(mapping);
    };
    var generateProject = function (input, template, options) {
        if (options === void 0) { options = {}; }
        return __awaiter(_this, void 0, void 0, function () {
            var schemaValidationResult, uidl, contentValidationResult, _a, components, root, routes, localDependenciesPrefix, pagePromises, componentPromises, createdPageFiles, createdComponentFiles, joinedPageFiles, pageFiles, joinedComponentFiles, componentFiles, publicFiles, manifestFile, htmlIndexFile, _b, routerFile, routerDependencies, srcFiles, collectedDependencies, packageJSONFile, distFiles, filesWithPath, outputFolder;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        // Step 0: Validate project input
                        if (!options.skipValidation) {
                            schemaValidationResult = validator.validateProjectSchema(input);
                            if (!schemaValidationResult.valid) {
                                throw new Error(schemaValidationResult.errorMsg);
                            }
                        }
                        uidl = teleport_uidl_validator_1.Parser.parseProjectJSON(input);
                        contentValidationResult = validator.validateProjectContent(uidl);
                        if (!contentValidationResult.valid) {
                            throw new Error(contentValidationResult.errorMsg);
                        }
                        // Step 1: Add any custom mappings found in the options
                        if (options.customMapping) {
                            vueGenerator.addMapping(options.customMapping);
                        }
                        _a = uidl.components, components = _a === void 0 ? {} : _a, root = uidl.root;
                        routes = uidl_utils_1.extractRoutes(root);
                        localDependenciesPrefix = project_utils_1.generateLocalDependenciesPrefix(template, {
                            defaultComponentsPath: constants_1.DEFAULT_COMPONENT_FILES_PATH,
                            defaultPagesPath: constants_1.DEFAULT_PAGE_FILES_PATH,
                        });
                        pagePromises = routes.map(function (routeNode) {
                            var _a = routeNode.content, value = _a.value, node = _a.node;
                            var pageName = value.toString();
                            var componentUIDL = {
                                name: pageName,
                                node: node,
                                stateDefinitions: root.stateDefinitions,
                            };
                            var pageParams = {
                                componentGenerator: vueGenerator,
                                componentUIDL: componentUIDL,
                                generatorOptions: {
                                    localDependenciesPrefix: localDependenciesPrefix,
                                    assetsPrefix: constants_1.ASSETS_PREFIX,
                                    projectRouteDefinition: root.stateDefinitions.route,
                                },
                            };
                            return project_utils_1.createPageOutputs(pageParams);
                        });
                        componentPromises = Object.keys(components).map(function (componentName) {
                            var componentUIDL = components[componentName];
                            var componentParams = {
                                componentUIDL: componentUIDL,
                                componentGenerator: vueGenerator,
                                generatorOptions: {
                                    assetsPrefix: constants_1.ASSETS_PREFIX,
                                    projectRouteDefinition: root.stateDefinitions.route,
                                },
                            };
                            return project_utils_1.createComponentOutputs(componentParams);
                        });
                        return [4 /*yield*/, Promise.all(pagePromises)];
                    case 1:
                        createdPageFiles = _c.sent();
                        return [4 /*yield*/, Promise.all(componentPromises)
                            // Step 5: The generated page and component files are joined
                        ];
                    case 2:
                        createdComponentFiles = _c.sent();
                        joinedPageFiles = project_utils_1.joinGeneratorOutputs(createdPageFiles);
                        pageFiles = [].concat(joinedPageFiles.files);
                        joinedComponentFiles = project_utils_1.joinGeneratorOutputs(createdComponentFiles);
                        componentFiles = joinedComponentFiles.files;
                        publicFiles = [];
                        if (uidl.globals.manifest) {
                            manifestFile = project_utils_1.createManifestJSONFile(uidl, constants_1.ASSETS_PREFIX);
                            publicFiles.push(manifestFile);
                        }
                        htmlIndexFile = component_generators_1.createHtmlEntryFile(uidl, { assetsPrefix: constants_1.ASSETS_PREFIX });
                        publicFiles.push(htmlIndexFile);
                        return [4 /*yield*/, component_generators_1.createRouterFile(root)];
                    case 3:
                        _b = _c.sent(), routerFile = _b.routerFile, routerDependencies = _b.dependencies;
                        srcFiles = [].concat(routerFile);
                        collectedDependencies = __assign({}, routerDependencies, joinedPageFiles.dependencies, joinedComponentFiles.dependencies);
                        packageJSONFile = project_utils_1.createPackageJSONFile(options.sourcePackageJson || constants_1.DEFAULT_PACKAGE_JSON, {
                            dependencies: collectedDependencies,
                            projectName: uidl.name,
                        });
                        distFiles = [packageJSONFile];
                        // Step 9: Build the folder structure
                        template.meta = template.meta || {};
                        filesWithPath = [
                            {
                                path: [],
                                files: distFiles,
                            },
                            {
                                path: template.meta.srcFilesPath || constants_1.DEFAULT_SRC_FILES_PATH,
                                files: srcFiles,
                            },
                            {
                                path: template.meta.componentsPath || constants_1.DEFAULT_COMPONENT_FILES_PATH,
                                files: componentFiles,
                            },
                            {
                                path: template.meta.pagesPath || constants_1.DEFAULT_PAGE_FILES_PATH,
                                files: pageFiles,
                            },
                            {
                                path: template.meta.publicFiles || constants_1.DEFAULT_PUBLIC_FILES_PATH,
                                files: publicFiles,
                            },
                        ];
                        outputFolder = project_utils_1.injectFilesInFolderStructure(filesWithPath, template);
                        return [2 /*return*/, {
                                outputFolder: outputFolder,
                                assetsPath: 'src' + constants_1.ASSETS_PREFIX,
                            }];
                }
            });
        });
    };
    return {
        addCustomMapping: addCustomMapping,
        generateProject: generateProject,
    };
};
exports.default = exports.createVueBasicGenerator();
//# sourceMappingURL=index.js.map