"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var project_utils_1 = require("@teleporthq/teleport-generator-shared/lib/utils/project-utils");
var constants_1 = require("./constants");
exports.buildFolderStructure = function (files, template) {
    var componentFiles = files.componentFiles, distFiles = files.distFiles, pageFiles = files.pageFiles, srcFiles = files.srcFiles, publicFiles = files.publicFiles;
    template.meta = template.meta || {};
    var templateFolder = template.templateFolder;
    templateFolder = project_utils_1.injectFilesToPath(templateFolder, null, distFiles);
    var srcFilesPath = template.meta.srcFilesPath || constants_1.DEFAULT_SRC_FILES_PATH;
    templateFolder = project_utils_1.injectFilesToPath(templateFolder, srcFilesPath, srcFiles);
    var componentFilesPath = template.meta.componentsPath || constants_1.DEFAULT_COMPONENT_FILES_PATH;
    templateFolder = project_utils_1.injectFilesToPath(templateFolder, componentFilesPath, componentFiles);
    var pageFilesPath = template.meta.pagesPath || constants_1.DEFAULT_PAGE_FILES_PATH;
    templateFolder = project_utils_1.injectFilesToPath(templateFolder, pageFilesPath, pageFiles);
    var publicFilesPath = template.meta.publicFilesPath || constants_1.DEFAULT_PUBLIC_FILES_PATH;
    templateFolder = project_utils_1.injectFilesToPath(templateFolder, publicFilesPath, publicFiles);
    return templateFolder;
};
//# sourceMappingURL=utils.js.map